# RePiX VR - Educational Application to teach the Rendering Pipeline in VR

Code repository for the project RePiX VR, an educational application, which is developed for learners, teachers and researchers interested in VR and the Computer Graphics Rendering Pipeline. We developed the main application in Unity (editor version 2019.4.8.f1, actually (6.7.2023) being in the process of updating to editor version 2021.3.15f1), It contains a guided tour through the pipeline. You can for example modify the view frustum and create your own first mesh. Currently we are using SteamVR, in the long run we want to switch to UnityXR. That is, at the moment you still have to install Steam and launch SteamVR. We also need VivePort (https://www.viveport.com/).

## Setup
1. Clone or download this repository. If it stucks, ensure you have installed "Git LFS" (https://docs.gitlab.com/ee/topics/git/lfs/) and download missing large assets after `git clone` with `git checkout` or `git fetch`.
2. Open this project in Unity and let Unity install everything missing package. Accept all notifications.
3. Go to scene "Assets/EducationalVR.Apps.RenderingPipeline/Resources/Scenes/GuidedTour" and start this scene.

## Two ways to start the xAPI tracking
1. Local: 
    1. Start Socket Server (https://gitlab.com/learntech-rwth/repix-vr/xapi-collector-server).
    2. Start Configuration Panel (https://gitlab.com/learntech-rwth/repix-vr/xapi-collector-frontend).
    3. Start Unity scene.
    4. Authenticate yourself.
    5. Choose your LRS Client inside the configuration panel (attention!: if you wish to do eye tracking, then do eye calibration before!).
    6. The client shall appear inside the configration panel.
    7. Configure your tracking session and press Play on wished client.
    8. Enjoy xAPI tracking
2. Electron App:
    1. Start Application
    3. Start Unity scene.
    4. Authenticate yourself or use a previous authentification, afterwards choose your LRS Client (attention!: if you wish to do eye tracking, then do eye calibration before!).
    5. The client shall appear inside the configration panel.
    6. Configure your tracking session and press Play on wished client.
    7. Enjoy xAPI tracking

For the usage of the eye tracking system of the HTC Vive Pro Eye, the Vive SRanipal SDK needs to be installed. Download SDK and Runtime!
- ViveSR: https://developer.vive.com/resources/vive-sense/sdk/vive-eye-tracking-sdk-sranipal/
- Doesn't work? Install Viveport?

## Fetch xAPI definitions 
1. Download the definitions fetcher executable from CI pipeline artifacts https://gitlab.com/learntech-rwth/repix-vr/xapi-definitions-fetcher/-/pipelines
2. Go inside of Unity to Windows > xAPI > Fetcher and configure all settings (path to exectuable, output directory, ...)
3. For gitlab variant type also into your secret key and project id from gitlab.
4. Click on fetch xAPI statements button.

## Contribution
The most implementations can be found in folder "Assets/EducationalVR", "Assets/EducationalVR.Apps.RenderingPipeline", "Assets/VRDataCollector", "Assets/xAPI_Definitions_Fetcher_Unity" and the autogenerated folder "Assets/xAPI".

## Used packages
All packages are installed inside the Assets folder.

- DefaultPlayables: https://assetstore.unity.com/packages/essentials/default-playables-95266
- ProBuilder: https://unity3d.com/de/unity/features/worldbuilding/probuilder
- QuickOutline: https://assetstore.unity.com/packages/tools/particles-effects/quick-outline-115488
- SocketIO for Unity: https://assetstore.unity.com/packages/tools/network/socket-io-for-unity-21721 with some changes in Fork https://github.com/SGoerzen/unity-socket.io
- SteamVR: https://assetstore.unity.com/packages/tools/integration/steamvr-plugin-32647
- TextMesh Pro: https://docs.unity3d.com/Manual/com.unity.textmeshpro.html
- Tobii / Tobii XR: https://developer.tobii.com/pc-gaming/unity-sdk/getting-started/
- UCLAGamLab: https://assetstore.unity.com/packages/vfx/shaders/directx-11/ucla-wireframe-shader-21897
- UMotion Editor: https://assetstore.unity.com/packages/tools/animation/umotion-community-animation-editor-95986
- UnityMainThreadDispatcher: https://github.com/PimDeWitte/UnityMainThreadDispatcher
- VRDataCollector: https://gitlab.com/learntech-rwth/mmla/xapi_datacollector_unity (UPGRADED IN ASSETS FOLDER)

## FAQ
It starts in Desktop Mode?
- Did you start SteamVR? Is VivePort properly installed?
Why are some textures missing?
- Maybe you need to install Blender, because there might be assets created in Blender and not properly imported (to work without Blender). Please report the issue (https://gitlab.com/learntech-rwth/repix-vr/repix-vr-app/-/issues).
How do I change the stage quickly?
- Use the shortcuts. Press the spacebar and …

|chapter|shortcut "spacebar" +|
| ------ | ------ |
|tutorial|1|
|application|2|
|geometry|3|
|transformation|4|
|clipping|5|
|rasterization|6|
|local lightning|7|
|texturing |8|
|visibility test|9|
|image|0|

## Contributing
Pull requests are welcome. For major changes, please open an issue first to discuss what you would like to change.


## License
[MIT](https://choosealicense.com/licenses/mit/)

## Authors and acknowledgment
Responsible: Learning Technologies Research Group, RWTH Aachen University, Germany.
Do you have questions/ ideas/ want to contribute - write us:
Birte Heinemann (heinemann@cs.rwth-aachen.de) and Sergej Görzen (goerzen@cs.rwth-aachen.de)

### Thank you
- Thank you to all the participants in our evaluations.
- Thank you to the students, who contributed. It's great to do research with you.
    - Especially to our student workers: Tobias Möhring, Sam Matiussi, Martin Khadjavian, Ana Dragoljic
    - And to the thesis: Julian Koch, Ana Dragoljic, Phillipp Koriath, Zihao Zhang, Andreas Stiller, Sam Matiussi, Thorben Sußebach, Sergej Neuberger
    - Team Flauschig and the rest of the RFC 2021 (Research Focus Class): Lejla Gusig, Sergej Neuberger, Han W., Maged Mortaga, Tasin Siddiqi, Fynn Mazurkiewicz, Martin Khadjavian, Ali Ismail und Tobias Möhring
